<template>
  <fieldset class="border">
    <legend class="w-auto" style="margin-top: -11px;">
      <b class="fs-5" v-text='descTipoBecario'></b>
      <span class="text-destacado  fs-7" v-html='descVisado' v-show='verVisado'></span>
      <span class="text-destacado  fs-7" v-html='descMismaSeccion' v-show='verMismaSeccion'></span>
    </legend>
    <div class="row mt-4 actualizaBecas">
      <div class="col-3">
        <label :for='"tipoDoc" + descTipoBecario' class="form-label-act">Tipo Doc.:</label>
        <select :disabled='!esHabilitadoBuscar' :required="esObligatorio" v-model="form.tipoDoc"
          class="form-select form-select-sm" :id='"tipoDoc" + descTipoBecario' @change="ocultar()">
          <option :value="null" v-text="'--Seleccione--'"></option>
          <option v-for="tipoDoc in tiposDocStore.getTiposDoc()" :key="tipoDoc.id_tipo_doc" :value="tipoDoc"
            v-text="tipoDoc.d_tipo_doc"></option>
        </select>
      </div>
      <div class="col-3">
        <label :for='"doc" + descTipoBecario' class="form-label-act">N° Doc.:</label>
        <input :disabled='!esHabilitadoBuscar' :required="esObligatorio" type="number" min="100000" max="99999999"
          ref='docBecOApod' v-model.trim="form.becario.doc" class="form-control form-control-sm"
          placeholder="N° Documento" autocomplete="off" :id='"doc" + descTipoBecario' @input="ocultar()" />
      </div>
      <div class="col text-end mt-3">
        <!--
          <button :disabled='!esValidoBuscar' type="button" class="btn btn-principal px-3 mt-2" :alt='textoBotonBuscar'
          :title='textoBotonBuscar' @click="validarBusqueda()">
        -->
        <button v-show='esValidoBuscar' type="button" class="btn btn-principal px-3 mt-2" :alt='textoBotonBuscar'
          :title='textoBotonBuscar' @click="validarBusqueda()">
          {{ textoBotonBuscar }}
        </button>
        <!-- <button :disabled='!esValidoEliminar' type="button" class="btn btn-danger mt-2 p-1 px-2 mx-2 text-uppercase"
          :alt='textoBotonEliminar' :title='textoBotonEliminar' @click="clear()"> -->
        <button v-show='esValidoEliminar' type="button" class="btn btn-danger mt-2 p-1 px-2 mx-2 text-uppercase"
          :alt='textoBotonEliminar' :title='textoBotonEliminar' @click="clear()">
          <i class="bi bi-eraser fonts-sm"></i>
        </button>
      </div>
    </div>
    <div v-show='verForm'>

      <div class="row actualizaBecas">
        <div class="col-6">
          <label :for='"apellido" + descTipoBecario' class="form-label-act">Apellido/s:</label>
          <input :disabled="!esHabilitado" required type="text" v-model.trim="form.becario.apellido"
            class="form-control form-control-sm" autocomplete="off" :id='"apellido" + descTipoBecario'
            @input='convertMayus("apellido")' />
        </div>
        <div class="col-6">
          <label :for='"nombres" + descTipoBecario' class="form-label-act">Nombre/s:</label>
          <input :disabled="!esHabilitado" required type="text" v-model.trim="form.becario.nombres"
            class="form-control form-control-sm" autocomplete="off" :id='"nombres" + descTipoBecario'
            @input='convertMayus("nombres")' />
        </div>
      </div>

      <div class="row actualizaBecas">
        <div class="col-3">
          <label :for='"fNacimiento" + descTipoBecario' class="form-label-act">F. Nacimiento:</label>
          <input :disabled="!esHabilitado" required type="date" v-model.trim="form.becario.f_nacimiento"
            class="form-control form-control-sm" autocomplete="off" :id='"fNacimiento" + descTipoBecario' />
        </div>
        <div class="col-2">
          <label :for='"edad" + descTipoBecario' class="form-label-act">Edad:</label>
          <input disabled required type="text" :value='edadMostrar' class="form-control form-control-sm"
            autocomplete="off" :id='"edad" + descTipoBecario' />
        </div>
        <div class="col-3">
          <label :for='"genero" + descTipoBecario' class="form-label-act">G&eacute;nero:</label>
          <select :disabled="!esHabilitado" required v-model="form.genero" class="form-select form-select-sm"
            :id='"genero" + descTipoBecario'>
            <option :value="null" v-text="'--Seleccione--'"></option>
            <option v-for="genero in generosStore.getGeneros()" :key="genero.id_genero" :value="genero"
              v-text="genero.d_genero"></option>
          </select>
        </div>
        <div class="col-4">
          <label :for='"cuil" + descTipoBecario' class="form-label-act">C.U.I.T./C.U.I.L.:</label>
          <input-cuil v-if='verForm' v-model='form.cuil' :nro-doc='form.becario.doc' :validate='true'
            :show-label='false' :disabled='!esHabilitado' :required='true' :autocomplete='"off"'
            :id='"cuil" + descTipoBecario' />
        </div>
      </div>

      <div class="row actualizaBecas">
        <div class="col-5">
          <label :for='"calleDom" + descTipoBecario' class="form-label-act">Calle:</label>
          <input :disabled="!esHabilitado" required type="text" v-model.trim="form.becario.calle_dom"
            class="form-control form-control-sm" autocomplete="off" :id='"calleDom" + descTipoBecario' />
        </div>
        <div class="col-2">
          <label :for='"nroDom" + descTipoBecario' class="form-label-act">Nro.:</label>
          <input :disabled="!esHabilitado" type="text" v-model.trim="form.becario.nro_dom"
            class="form-control form-control-sm" autocomplete="off" :id='"nroDom" + descTipoBecario' />
        </div>
        <div class="col-2">
          <label :for='"pisoDom" + descTipoBecario' class="form-label-act">Piso:</label>
          <input :disabled="!esHabilitado" type="text" v-model.trim="form.becario.piso_dom"
            class="form-control form-control-sm" autocomplete="off" :id='"pisoDom" + descTipoBecario' />
        </div>
        <div class="col-2">
          <label :for='"deptoDom" + descTipoBecario' class="form-label-act">Depto.:</label>
          <input :disabled="!esHabilitado" type="text" v-model.trim="form.becario.depto_dom"
            class="form-control form-control-sm" autocomplete="off" :id='"deptoDom" + descTipoBecario' />
        </div>
      </div>

      <div class="row actualizaBecas">
        <div class="col-6">
          <label :for='"partido" + descTipoBecario' class="form-label-act">Partido:</label>
          <auto-complete v-model="form.partido" :elements="partidosStore.getPartidos()" initKey=""
            :placeholder='"Partido"' :minLength="2" :disabled="!esHabilitado" :required="true" autocomplete="off"
            :id='"partido" + descTipoBecario' />
        </div>
        <div class="col-6" v-show='verFormSeccion'>
          <label :for='"seccion" + descTipoBecario' class="form-label-act">Secci&oacute;n:</label>
          <!--
            <select disabled required v-model="form.seccion" class="form-select form-select-sm" :style='"appearance: none;"'
              :id='"seccion" + descTipoBecario'>
              <option :value="null" v-text="'--Seleccione--'"></option>
              <option v-for="seccion in seccionesStore.getSecciones()" :key="seccion.id_seccion" :value="seccion"
                v-text="seccion.seccion"></option>
            </select>
          -->
          <auto-complete v-model="form.seccion" :elements="seccionesStore.getSecciones()" initKey=""
            :placeholder='"Secci&oacute;n"' :minLength="2" :disabled="true" :required="true" autocomplete="off"
            :id='"seccion" + descTipoBecario' />
        </div>
      </div>
      <div class="row actualizaBecas" v-show='verFormPartido'>
        <div class="col-6">
          <label :for='"localidad" + descTipoBecario' class="form-label-act">Localidad:</label>
          <auto-complete v-model="form.localidad" :elements="filteredLocalidades" initKey="" :placeholder='"Localidad"'
            :minLength="2" :disabled="!esHabilitado" :required="true" autocomplete="off"
            :id='"localidad" + descTipoBecario' />
        </div>
        <div class="col-6" v-show='hayLocalidad'>
          <label :for='"codPostal" + descTipoBecario' class="form-label-act">C&oacute;d. Postal:</label>
          <input disabled required type="text" v-model.trim="form.becario.cod_postal"
            class="form-control form-control-sm" autocomplete="off" :id='"codPostal" + descTipoBecario' />
        </div>
      </div>
      <div class="row actualizaBecas" v-show='verBapro'>
        <div class="col-6">
          <label :for='"baproSucursal" + descTipoBecario' class="form-label-act">Sucursal Bapro:</label>
          <auto-complete v-model="form.baproSucursal" :elements="baproSucursalesStore.getBaproSucursales()" initKey=""
            :placeholder='"Sucursal"' :minLength="2" :disabled="!esHabilitado" :required="true" autocomplete="off"
            :id='"baproSucursal" + descTipoBecario' />
        </div>
        <div class="col-6" v-show='hayBaproSucursal'>
          <label :for='"cbuCompleto" + descTipoBecario' class="form-label-act">CBU:</label>
          <input disabled type="text" v-model.trim="form.becario.cbu_completo" class="form-control form-control-sm"
            autocomplete="off" :id='"cbuCompleto" + descTipoBecario' />
        </div>
      </div>
      <!--
      <div class="row mt-3" v-show='hayControlDesig'>
        <div class="col">
          <label :for='"controlDesig" + descTipoBecario' class="form-label-act">Otras Designaciones:</label>
          <textarea v-model="form.becario.control_designacion" class="form-control form-control-sm" autocomplete="off"
            :id='"controlDesig" + descTipoBecario'>
        </textarea>
        </div>
      </div>
    -->
    </div>
  </fieldset>
</template>

<script setup lang="ts">

// Librerias
import { DateTime } from "luxon";
import type { DurationUnits } from "luxon";
import { reactive, computed, ref, toRef, watch, watchEffect, onMounted } from "vue";
import type { Ref } from "vue";
import { AutoComplete, InputCuil, Cuil, Modal } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import { urlApi, isEmpty, loading } from "@/shared.js";
// Entidades
import Becario from "@/entities/becas/Becario";
import TipoDoc from "@/entities/becas/TipoDoc";
import Genero from "@/entities/becas/Genero";
import Partido from "@/entities/becas/Partido";
import Seccion from "@/entities/becas/Seccion";
import Localidad from "@/entities/becas/Localidad";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
// Stores
import { useBecariosStore } from "@/stores/becas/becarios";
import { useTiposDocStore } from "@/stores/becas/tiposDoc";
import { useGenerosStore } from "@/stores/becas/generos";
import { usePartidosStore } from "@/stores/becas/partidos";
import { useSeccionesStore } from "@/stores/becas/secciones";
import { useLocalidadesStore } from "@/stores/becas/localidades";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";

const becariosStore = useBecariosStore();
const tiposDocStore = useTiposDocStore();
const generosStore = useGenerosStore();
const partidosStore = usePartidosStore();
const seccionesStore = useSeccionesStore();
const localidadesStore = useLocalidadesStore();
const baproSucursalesStore = useBaproSucursalesStore();

const props = withDefaults(defineProps<{
  modelValue: Becario,
  idPerfilUsuario: number,
  idBeca: number,
  esBecario: boolean,
  esMismaSeccion: boolean,
  esDocHabilitado: boolean,
  esApoderadoOblig: boolean,
  esBecYApodIguales: boolean,
  hayBecOApod: boolean,
  inicioValidar: boolean,
  inicioGuardar: boolean,
  inicioRevertir: boolean
}>(), {
  modelValue: Object.create(new Becario()),
  idPerfilUsuario: NaN,
  idBeca: NaN,
  esBecario: true,
  esMismaSeccion: true,
  esDocHabilitado: true,
  esApoderadoOblig: false,
  esBecYApodIguales: false,
  hayBecOApod: false,
  inicioValidar: false,
  inicioGuardar: false,
  inicioRevertir: false
});

const emits = defineEmits(["update:modelValue", "actHayBecario", "finValidar", "finGuardar", "finRevertir"]);

const convertMayus = (campo: keyof Becario) => {
  if (!isEmpty(form.becario[campo])) {
    // @ts-ignore
    form.becario[campo] = String(form.becario[campo]).toUpperCase();
  }
};
const fechaActual = () => DateTime.now().toFormat('yyyy-MM-dd');
const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const fechasDif = (f_minuendo: string, f_sustraendo: string, unidad: DurationUnits) => DateTime.fromISO(f_minuendo).diff(DateTime.fromISO(f_sustraendo), unidad).toObject();
const fechasDifAnios = (f_minuendo: string, f_sustraendo: string) => fechasDif(f_minuendo, f_sustraendo, 'years').years!;

const filteredLocalidades: Ref<Localidad[]> = toRef([]);

const form = reactive({
  becario: computed({
    get() {
      return props.modelValue;
    },
    set(value) {
      emits('update:modelValue', value);
    }
  }),
  tipoDoc: null as TipoDoc | null,
  genero: null as Genero | null,
  cuil: new Cuil() as Cuil,
  partido: undefined as Partido | undefined,
  //seccion: null as Seccion | null,
  seccion: undefined as Seccion | undefined,
  localidad: undefined as Localidad | undefined,
  baproSucursal: undefined as BaproSucursal | undefined
});

const hayUsuarioActivo = computed(() => !isEmpty(props.idPerfilUsuario));
const esAltaBeca = computed(() => isEmpty(props.idBeca));
const idBeca = computed(() => (!esAltaBeca.value) ? props.idBeca : undefined);
const esAltaBecario = computed(() => isEmpty(form.becario.id_becario));
const descTipoBecario = computed(() => (props.esBecario) ? "Becario" : "Apoderado");
const docBecOApod = ref(null);
const hayVisado = computed(() => !isEmpty(form.becario.f_visado_beca_min));
const descVisado = computed(() => (hayVisado.value) ? ("&nbsp;&nbsp;Tiene otra beca visada el d&iacute;a " + fechaMostrar(form.becario.f_visado_beca_min) + "&nbsp;&nbsp;") : (""));
const verVisado = computed(() => !isEmpty(descVisado.value));
const descMismaSeccion = computed(() => (!props.esMismaSeccion && props.esBecario && verForm.value) ? ("&nbsp;&nbsp;No coincide secci&oacute;n&nbsp;&nbsp;") : (""));
const verMismaSeccion = computed(() => !isEmpty(descMismaSeccion.value));
//const textoBotonBuscar = computed(() => ((props.esAltaBeca) ? "Buscar" : "Editar") + " " + descTipoBecario.value.toLowerCase());
const textoBotonBuscar = computed(() => "Buscar " + descTipoBecario.value.toLowerCase());
const textoBotonEliminar = computed(() => "Eliminar " + descTipoBecario.value.toLowerCase());
const verForm = toRef(false);
const hayNroDoc = computed(() => !isEmpty(form.becario.doc));
const edad = computed(() => fechasDifAnios(fechaActual(), form.becario.f_nacimiento));
const edadMostrar = computed(() => (edad.value >= 0) ? Math.trunc(edad.value) : "");
//const hayCuil = computed(() => !Object(form.cuil).values.includes(null));
const hayCuil = computed(() => !isEmpty(form.cuil.getCuil()));
const esCuilValido = computed(() => form.cuil.validarCuil(form.becario.doc));
const hayPartido = computed(() => !isEmpty(form.partido));
const verFormPartido = computed(() => !isEmpty(filteredLocalidades.value));
const verFormSeccion = computed(() => verFormPartido.value && props.esBecario);
const hayLocalidad = computed(() => !isEmpty(form.localidad));
const verBapro = computed(() => (props.esBecario && !props.esApoderadoOblig && !props.hayBecOApod) || (!props.esBecario));
const hayBaproSucursal = computed(() => !isEmpty(form.baproSucursal));
//const hayControlDesig = computed(() => !isEmpty(form.becario.control_designacion));
const hayCbu = computed(() => !isEmpty(form.becario.cbu_completo));
const hayEstado = computed(() => !isEmpty(form.becario.estado));
const hayIdBaproEstado = computed(() => !isEmpty(form.becario.id_baproestado));
const esInicioValidar = computed(() => props.inicioValidar);
const esInicioGuardar = computed(() => props.inicioGuardar);
const esInicioRevertir = computed(() => props.inicioRevertir);
const idRevertir = toRef(null as number | null);
const esObligatorio = computed(() => (props.esBecario) || (!props.esBecario && props.esApoderadoOblig));
const esHabilitadoUsuYBaproEstado = computed(() => ((hayUsuarioActivo.value) && (props.idPerfilUsuario === 1)) && ((hayIdBaproEstado.value) && (form.becario.id_baproestado === 1)));
const esHabilitado = computed(() => props.esDocHabilitado && (!hayVisado.value || esHabilitadoUsuYBaproEstado.value));
const esHabilitadoBuscar = computed(() => esAltaBeca.value || props.esDocHabilitado);
const esValidoBuscar = computed(() => !verForm.value && esHabilitadoBuscar.value);
const esHabilitadoEliminar = computed(() => (esAltaBeca.value) || (props.esDocHabilitado && !esObligatorio.value));
const esValidoEliminar = computed(() => verForm.value && esHabilitadoEliminar.value);
const esGuardar = computed(() => esObligatorio.value || esValidoEliminar.value);

watch(esAltaBecario, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    if (newValue) {
      limpiar();
    } else {
      cargarEdicion();
    }
  }
});

watch(hayNroDoc, (newValue, oldValue) => {
  if (newValue !== oldValue && !newValue && props.esBecario) {
    (docBecOApod.value as any).focus();
  }
});

watch(hayPartido, async (newValue, oldValue) => {
  let promises: Promise<unknown>[] = [];
  if (newValue !== oldValue) {
    if (newValue) {
      loading.show();
      promises = [seccionesStore.findSeccion(form.partido?.id_seccion!), localidadesStore.filterLocalidades(form.partido?.id_partido!)];
      await Promise.all(promises).then(values => {
        //form.seccion = (values[0] !== null) ? Object.assign(new Seccion(), values[0]) : null;
        form.seccion = (values[0] !== null) ? Object.assign(new Seccion(), values[0]) : undefined;
        filteredLocalidades.value = (values[1] !== null) ? Object.assign(new Array<Localidad>(), values[1]) : [];
        //form.becario.id_seccion = (form.seccion !== null) ? form.seccion.id_seccion : undefined;
        //form.becario.seccion = (form.seccion !== null) ? form.seccion.seccion : undefined;
        form.becario.id_seccion = (form.seccion !== undefined) ? form.seccion.id_seccion : undefined;
        form.becario.seccion = (form.seccion !== undefined) ? form.seccion.seccion : undefined;
        //loading.hide();
      }).catch(function () {
        //loading.hide();
      });
      loading.hide();
    } else {
      //form.seccion = null;
      form.seccion = undefined;
      form.localidad = undefined;
      filteredLocalidades.value = [];
      form.becario.id_seccion = undefined;
      form.becario.seccion = undefined;
      form.becario.cod_postal = undefined;
    }
  }
});

watch(hayLocalidad, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    if (newValue) {
      form.becario.cod_postal = form.localidad!.cod_postal;
    } else {
      form.becario.cod_postal = undefined;
    }
  }
});

watch(verBapro, (newValue, oldValue) => {
  if (newValue !== oldValue && !newValue) {
    form.baproSucursal = undefined;
    form.becario.cbu_completo = undefined;
  }
});

watch(hayBaproSucursal, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    form.becario.baprosuc = Number(form.baproSucursal?.c_bapro);
    if (!newValue) {
      form.becario.cbu_completo = undefined;
    }
  }
});

watch(verForm, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    actHayBecario(newValue);
  }
});

watch(esInicioValidar, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    if (esGuardar.value) {
      validar();
    } else {
      finValidar(true);
    }
  }
});

watch(esInicioGuardar, (newValue, oldValue) => {
  const parametros = {
    esExito: true as boolean,
    idBecOApod: null as number | null
  };
  if (newValue !== oldValue && newValue) {
    if (esGuardar.value) {
      agregarOEditar();
    } else {
      finGuardar(parametros);
    }
  }
});

watch(esInicioRevertir, (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    eliminarORevertir();
  }
});

onMounted(async () => {
  await cargaInicial();
});

async function cargaInicial() {
  form.tipoDoc = (isEmpty(form.tipoDoc)) ? await tiposDocStore.findTipoDoc(1) : form.tipoDoc;
  if (esAltaBeca.value && props.esBecario) {
    (docBecOApod.value as any).focus();
  }
}

function limpiar() {
  //form.tipoDoc = null;
  form.genero = null;
  //form.cuil = null;
  form.cuil.clearCuil();
  form.partido = undefined;
  //form.seccion = null;
  form.seccion = undefined;
  form.localidad = undefined;
  form.baproSucursal = undefined;
  //form.becario.estado = "A";
  //verForm.value = false;
}

async function clear() {
  //function clear() {
  //form.tipoDoc = null;
  limpiar();
  form.tipoDoc = await tiposDocStore.findTipoDoc(1);
  form.becario.doc = undefined;
  ocultar();
}

function ocultar() {
  verForm.value = false;
  reiniciar();
}

function mostrar() {
  verForm.value = true;
}

async function cargarEdicion() {
  let promises: Promise<unknown>[] = [];
  let promiseTipoDoc: Promise<TipoDoc | null>;
  let promiseGenero: Promise<Genero | null>;
  let promisePartido: Promise<Partido | null>;
  let promiseLocalidad: Promise<Localidad | null>;
  let promiseBaproSucursal: Promise<BaproSucursal | null>;
  let partido: Partido | null;
  let localidad: Localidad | null;
  let baproSucursal: BaproSucursal | null;
  //loading.show();
  if (!isEmpty(form.becario.tipo_doc)) {
    promiseTipoDoc = tiposDocStore.findTipoDoc(Number(form.becario.tipo_doc));
    promises.push(promiseTipoDoc);
  }
  if (!isEmpty(form.becario.sexo)) {
    promiseGenero = generosStore.findGenero(form.becario.sexo!);
    promises.push(promiseGenero);
  }
  if (!isEmpty(form.becario.id_partido)) {
    promisePartido = partidosStore.findPartido(form.becario.id_partido!);
    promises.push(promisePartido);
  }
  if (!isEmpty(form.becario.id_localidad)) {
    promiseLocalidad = localidadesStore.findLocalidad(form.becario.id_localidad!);
    promises.push(promiseLocalidad);
  }
  if (!isEmpty(form.becario.baprosuc)) {
    promiseBaproSucursal = baproSucursalesStore.findBaproSucursal(String(form.becario.baprosuc));
    promises.push(promiseBaproSucursal);
  }
  await Promise.all(promises).then(async (values) => {
    //form.tipoDoc = (values[0] !== null) ? Object.assign(new TipoDoc(), values[0]) : null;
    //form.genero = (values[1] !== null) ? Object.assign(new Genero(), values[1]) : null;
    //form.partido = (values[2] !== null) ? Object.assign(new Partido(), values[2]) : undefined;
    //form.seccion = (values[3] !== null) ? Object.assign(new Seccion(), values[3]) : null;    
    //form.localidad = (values[4] !== null) ? Object.assign(new Localidad(), values[4]) : undefined;
    form.tipoDoc = promises.includes(promiseTipoDoc) ? (await promiseTipoDoc) : null;
    form.genero = promises.includes(promiseGenero) ? (await promiseGenero) : null;
    //form.cuil.setDatos(Number(form.becario.cuil.substring(0, 2)), Number(form.becario.cuil.substring(2, 10)), Number(form.becario.cuil.substring(10, 11)));
    form.cuil.setCuil((!isEmpty(form.becario.cuil)) ? form.becario.cuil : form.cuil.cuil);
    partido = promises.includes(promisePartido) ? (await promisePartido) : null;
    localidad = promises.includes(promiseLocalidad) ? (await promiseLocalidad) : null;
    baproSucursal = promises.includes(promiseBaproSucursal) ? (await promiseBaproSucursal) : null;
    form.partido = (partido !== null) ? partido : undefined;
    form.localidad = (localidad !== null) ? localidad : undefined;
    form.baproSucursal = (baproSucursal !== null) ? baproSucursal : undefined;
    //form.becario.cod_postal = (!isEmpty(form.localidad)) ? form.becario.cod_postal : "";
    form.becario.cod_postal = (!isEmpty(form.localidad)) ? form.localidad!.cod_postal : undefined;
    mostrar();
    //verForm.value = true;
    //loading.hide();
  }).catch(function () {
    //loading.hide();
  });
  loading.hide();
}

function validarBusqueda() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  const tipoBecario: string = descTipoBecario.value.toLowerCase();
  const lengthNroDoc: number = String(form.becario.doc).length;
  if (isEmpty(form.tipoDoc)) {
    swal.html = "Por favor, seleccione el tipo de documento del " + tipoBecario + ".";
  } else if (isEmpty(form.becario.doc)) {
    swal.html = "Por favor, complete el n&uacute;mero de documento del " + tipoBecario + ".";
  } else if (lengthNroDoc < 7 || lengthNroDoc > 8) {
    swal.html = "Por favor, compruebe que el n&uacute;mero de documento del " + tipoBecario + " posea entre siete y ocho d&iacute;gitos.";
  } else if (props.esBecYApodIguales) {
    swal.html = "Por favor, compruebe que el becario y el apoderado de la beca sean efectivamente personas distintas.";
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  buscar();
}

async function buscar() {
  /*
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  */
  const doc_becario = {
    tipo_doc: String(form.tipoDoc?.id_tipo_doc),
    doc: String(form.becario.doc).padStart(8, "0")
  };
  const tyn_doc_becario = doc_becario.tipo_doc.concat(doc_becario.doc);
  let becario: Becario | null;
  loading.show();
  //becario = await becariosStore.findBecarioByDoc(doc_becario);
  becario = await becariosStore.findBecarioByDoc({ tyn_doc: tyn_doc_becario, id_beca: idBeca.value }, false, props.esBecario);
  if (Swal.isVisible()) {
    clear();
    loading.hide();
  } else {
    form.becario.doc = doc_becario.doc;
    //if (isEmpty(becario)) {
    if (isEmpty(becario!.id_becario)) {
      //reiniciar();
      limpiar();
      mostrar();
      loading.hide();
      /* 
      } else if (!isEmpty(becario!.msj_validacion)) {
        swal.html = becario!.msj_validacion;
        Swal.fire(swal);
        loading.hide();
        */
    } else {
      form.becario = Object.assign(new Becario(), becario);
    }
  }
}

function reiniciar() {
  const becario = new Becario();
  becario.doc = form.becario.doc!;
  form.becario = Object.assign(new Becario(), becario);
}

function actHayBecario(hayBecario: boolean) {
  const parametros = {
    esBecario: props.esBecario,
    hayBecario: hayBecario
  };
  emits("actHayBecario", parametros);
}

function validar() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  const tipoBecario = descTipoBecario.value.toLowerCase();
  const lengthNroDoc: number = String(form.becario.doc).length;
  let esExito: boolean = true;
  if (!verForm.value && !props.esBecario && props.esApoderadoOblig) {
    swal.html = "Por favor, compruebe que el becario, menor de edad, posea un apoderado efectivamente asociado para el cobro de la beca.";
  } else if (isEmpty(form.tipoDoc)) {
    swal.html = "Por favor, seleccione el tipo de documento del " + tipoBecario + ".";
  } else if (isEmpty(form.becario.doc)) {
    swal.html = "Por favor, complete el n&uacute;mero de documento del " + tipoBecario + ".";
  } else if (lengthNroDoc < 7 || lengthNroDoc > 8) {
    swal.html = "Por favor, compruebe que el n&uacute;mero de documento del " + tipoBecario + " posea entre siete y ocho d&iacute;gitos.";
  } else if (props.esBecYApodIguales) {
    swal.html = "Por favor, compruebe que el becario y el apoderado de la beca sean efectivamente personas distintas.";
  } else if (isEmpty(form.becario.apellido)) {
    swal.html = "Por favor, complete el/los apellido/s del " + tipoBecario + ".";
  } else if (isEmpty(form.becario.nombres)) {
    swal.html = "Por favor, complete el/los nombre/s del " + tipoBecario + ".";
  } else if (isEmpty(form.becario.f_nacimiento)) {
    swal.html = "Por favor, complete la fecha de nacimiento del " + tipoBecario + ".";
  } else if (isEmpty(edad.value)) {
    swal.html = "Por favor, compruebe la edad del " + tipoBecario + " y, ante cualquier inconveniente, avise al Administrador.";
  } else if ((props.esBecario) && ((edad.value! < 3) || (edad.value! > 90))) {
    swal.html = "Por favor, compruebe que la edad del " + tipoBecario + " sea de entre tres y noventa a&ntilde;os.";
  } else if ((!props.esBecario) && (edad.value! < 18)) {
    swal.html = "Por favor, compruebe que la edad del " + tipoBecario + " no sea menor a dieciocho a&ntilde;os.";
  } else if (isEmpty(form.genero)) {
    swal.html = "Por favor, seleccione el g&eacute;nero del " + tipoBecario + ".";
    //} else if (isEmpty(form.becario.cuil)) {
  } else if (!hayCuil.value) {
    swal.html = "Por favor, complete el C.U.I.T./C.U.I.L. del " + tipoBecario + ".";
  } else if (!esCuilValido.value) {
    swal.html = "Por favor, compruebe la validez del C.U.I.T./C.U.I.L. del " + tipoBecario + ".";
  } else if (isEmpty(form.becario.calle_dom)) {
    swal.html = "Por favor, complete la calle del domicilio del " + tipoBecario + ".";
  } /* else if (isEmpty(form.becario.nro_dom)) {
    swal.html = "Por favor, complete el n&uacute;mero del domicilio del " + tipoBecario + ".";
  } */ else if (!hayPartido.value) {
    swal.html = "Por favor, complete el partido territorial del " + tipoBecario + ".";
  } else if (isEmpty(form.seccion)) {
    swal.html = "Por favor, seleccione la secci&oacute;n electoral del " + tipoBecario + ".";
  } else if (!hayLocalidad.value) {
    swal.html = "Por favor, complete la localidad territorial del " + tipoBecario + ".";
  }
  /*
  else if (isEmpty(form.becario.cod_postal)) {
    swal.html = "Por favor, complete el c&oacute;digo postal del " + tipoBecario + ".";
  }
  */
  else if (verBapro.value && !hayBaproSucursal.value) {
    swal.html = "Por favor, complete la sucursal Bapro del " + tipoBecario + ".";
  }
  /*
  else if (!hayCbu.value) {
    swal.html = "Por favor, complete la Clave Bancaria Uniforme (CBU) del " + tipoBecario + ".";
  }
  */
  if (!isEmpty(swal.html)) {
    //Swal.fire(swal);    
    if (!Swal.isVisible()) {
      Swal.fire(swal);
    }
    esExito = false;
  }
  finValidar(esExito);
}

function agregarOEditar() {
  const accion: string = (esAltaBecario.value) ? "A" : "M";
  const url: string = (esAltaBecario.value) ? "addBecario" : "modifyBecario";
  const paramsRequest: any = {
    id_becario: form.becario.id_becario,
    tipo_doc: String(form.tipoDoc?.id_tipo_doc),
    doc: form.becario.doc,
    apellido: form.becario.apellido.toUpperCase(),
    nombres: form.becario.nombres.toUpperCase(),
    sexo: form.genero?.c_genero,
    f_nacimiento: form.becario.f_nacimiento,
    calle_dom: form.becario.calle_dom,
    nro_dom: !isEmpty(form.becario.nro_dom) ? form.becario.nro_dom : "",
    piso_dom: !isEmpty(form.becario.piso_dom) ? form.becario.piso_dom : "",
    depto_dom: !isEmpty(form.becario.depto_dom) ? form.becario.depto_dom : "",
    id_localidad: form.localidad?.id_localidad,
    id_partido: form.partido?.id_partido,
    cod_postal: form.becario.cod_postal,
    //cuil: form.becario.cuil,
    //cuil: String(form.cuil!.genero).concat(String(form.cuil!.dni), String(form.cuil!.verificador)),
    cuil: form.cuil.getCuilFormateado(),
    //baprosuc: Number(form.baproSucursal?.c_bapro),
    baprosuc: form.becario.baprosuc,
    cbu_bloq1: (hayCbu.value) ? form.becario.cbu_completo!.substring(0, 8) : null,
    cbu_bloq2: (hayCbu.value) ? form.becario.cbu_completo!.substring(8) : null,
    estado: (hayEstado.value) ? form.becario.estado : "A"
    //id_baproestado: ((!hayBaproSucursal.value || !hayCbu.value) ? null : ((!isEmpty(form.becario.id_baproestado)) ? form.becario.id_baproestado : 1))
  };
  guardar(accion, url, paramsRequest);
}

function eliminarORevertir() {
  const accion: string = (!esInicioRevertir.value) ? "B" : "R";
  const url: string = (!esInicioRevertir.value) ? "deleteBecario" : "revertBecario";
  const paramsRequest: any = {
    id_becario: (!esInicioRevertir.value) ? form.becario.id_becario : idRevertir.value
  };
  guardar(accion, url, paramsRequest);
}

async function guardar(accion: string, url: string, paramsRequest: any) {
  const swal_exito: SweetAlertOptions = {
    icon: "success",
    title: "&Eacute;xito",
    html: "",
    showConfirmButton: false,
    timer: 500,
  };
  const swal_error: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  const parametros = {
    esExito: true as boolean,
    idBecOApod: null as number | null
  };
  let becario: Becario | null = null;
  /*
  loading.show();
  if (!loading.isLoading()) {
    loading.show();
  }
  */
  await http.post<any>(urlApi + url, paramsRequest)
    .then(function (response: AxiosResponse<any, any>) {
      //form.becario.id_becario = !isEmpty(response.data.id_out) ? Number(response.data.id_out) : response.data.id_out;
      parametros.idBecOApod = (!isEmpty(response.data.id_out)) ? Number(response.data.id_out) : ((accion === "R") ? form.becario.id_becario : null);
      swal_exito.html = response.data.mensaje_out;
      form.becario.tipo_doc = String(form.tipoDoc!.id_tipo_doc);
      form.becario.sexo = form.genero!.c_genero;
      //form.becario.cuil = String(form.cuil!.genero).concat(String(form.cuil!.dni), String(form.cuil!.verificador));
      form.becario.cuil = form.cuil.getCuilFormateado();
      form.becario.id_partido = form.partido!.id_partido;
      form.becario.partido = form.partido!.partido;
      //form.becario.id_seccion = form.seccion!.id_seccion;
      //form.becario.seccion = form.seccion!.seccion;
      form.becario.id_localidad = form.localidad!.id_localidad;
      form.becario.localidad = form.localidad!.localidad;
      //form.becario.baprosuc = Number(form.baproSucursal!.c_bapro);
      form.becario.estado = paramsRequest.estado;
      //form.becario.id_baproestado = paramsRequest.id_baproestado;
      becario = Object.assign(new Becario(), form.becario);
      becario.id_becario = parametros.idBecOApod!;
      idRevertir.value = (accion === "A") ? becario.id_becario : null;
      becariosStore.abmBecario(becario, accion);
      /*
      loading.hide();
      Swal.fire(swal_exito).then(function (result: SweetAlertResult<any>) {
        if (result.dismiss === Swal.DismissReason.timer) {
          //console.log("I was closed by the timer")
          cerrar();
        }
      });
      */
    })
    .catch(function (error: AxiosError<string, any>) {
      if (Swal.getIcon()?.classList.contains("swal2-error") !== true) {
        if (error.response) {
          // Request made and server responded
          /*
          if (error.response.data.indexOf("|") !== -1) {
            swal_error.html = error.response.data.substring(
              error.response.data.indexOf("|") + 2,
              error.response.data.indexOf("Código") - 8
            );
          } else {
            swal_error.html =
              error.response.data.substring(
                error.response.data.indexOf("<h2>") + ("<h2>").length,
                error.response.data.indexOf("</h2>")
              );
          }
          */
          swal_error.html = error.response.data;
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
          //console.log(error.response.status);
          //console.log(error.response.headers);
          //console.log(error.response.data);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log("Error: the request was made but no response was received");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      }
      parametros.esExito = false;
    });
  if (!esInicioRevertir.value) {
    finGuardar(parametros);
  } else {
    finRevertir(parametros);
  }
}

function finValidar(esExito: boolean) {
  const parametros = {
    esBecario: props.esBecario,
    esExito: esExito
  };
  emits("finValidar", parametros);
}

function finGuardar(params: { esExito: boolean, idBecOApod: number | null }) {
  const parametros = {
    esBecario: props.esBecario,
    esExito: params.esExito,
    idBecOApod: params.idBecOApod
  };
  emits("finGuardar", parametros);
}

function finRevertir(params: { esExito: boolean, idBecOApod: number | null }) {
  const parametros = {
    esBecario: props.esBecario,
    esExito: params.esExito,
    idBecOApod: params.idBecOApod
  };
  /*
  if (params.esExito) {
    clear();
  }
  */
  emits("finRevertir", parametros);
}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
